jQuery.plugin("de_epages.customform.inc.customformaddfielddialog", {
	plugin: ['jQuery.dict', 'jQuery.tmpl', 'ep.ui.dialog', 'ep.ui.validate', 'ep.validate', 'ep.core', 'de_epages.core'],
	dict:	['ep.dict', 'de_epages.customform.dictionary'],
	tmpl: [
		'de_epages.customform.inc.customform-add',
		'de_epages.customform.inc.customform-fieldpreview'
	]
}, function($){

	$.extend($.scope("de_epages.customform.inc"), {
		customformGenerateAddDialog: function(options){
			/*
			 * @dictionary		ep.dict
			 *
			 * @translation		{Type}
			 *								{MandatoryStar}
			 *								{yes}
			 *								{no}
			 *								{Apply}
			 *								{Cancel}
			 *
			 *
			 * @dictionary		de_epages.customform.dictionary
			 *
			 * @translation		{FieldName}
			 *								{MandatoryForUsers}
			 *								{AdditionalFormFieldText}
			 *								{AddFormField}
			 */

			var o = $.extend({
//					ViewAction: undefined,
//					ObjectID: undefined,
//					element: undefined,
//					IsEditorMode: undefined,
					width: 800,
					height: 400,
					dialogContentId: 'addDialogContent',
					selectOptions: {},
					ChangeAction: 'AddField',
      		languageId: 1
				}, options),

				// translations
				epDict = $.dict('ep.dict'),
				customformDict = $.dict('de_epages.customform.dictionary'),
				translationsDialog = {
					tType: epDict.translate('Type'),
					tTitle: customformDict.translate('AddFormField'),
					tFieldName: customformDict.translate('FieldName'),
					tMandatoryStar: epDict.translate('MandatoryStar'),
					tMandatoryForUsers: customformDict.translate('MandatoryForUsers'),
					tYes: epDict.translate('yes'),
					tNo: epDict.translate('no'),
					tAdditionalFormFieldText: customformDict.translate('AdditionalFormFieldText'),
					tAdd: epDict.translate('Apply'),
					tCancel: epDict.translate('Cancel')
				},

				addDialog = undefined,
				// identify if plugin was called from preview view
				isEditorMode = (o.IsEditorMode===undefined)? '' : '&IsEditorMode='+o.IsEditorMode,

				// initialize
				init = function(){
					// if an element is defined
					if(o.element !== undefined){

						o.element.on('click', function(event){
							event.preventDefault();

							// remove already existing dialog
							if($('#'+o.dialogContentId).length){
								$('#'+o.dialogContentId).remove();
							}
							// append necessary template to document
							$.tmpl('de_epages.customform.inc.customform-add', $.extend({options: o.selectOptions, LangID: o.languageId}, translationsDialog)).appendTo('body');
							$('#'+o.dialogContentId+' input, #'+o.dialogContentId+' select').metaparse();

							// create dialog
							addDialog = ep('#'+o.dialogContentId).uiDialog({
								title: translationsDialog.tTitle,
								modal: true,
								width: o.width,
								//height: jQuery.browser.opera? ($(window).height()-50)*0.8 : 'auto',
								height: o.height,
								form: {
									action: '?ChangeAction='+o.ChangeAction+'&ViewAction='+o.ViewAction+'&ObjectID='+o.ObjectID + isEditorMode,
									method: 'post'
								},
								open: function(){
									var dialog = $(this),
										previewFieldType = dialog.find('.previewFieldType'),			// dom element for the preview template
										aliasFieldType = dialog.find('.aliasFieldType'),					// get dom element for the choosen field alias
										fieldSelect = dialog.find('select[name=FieldClassID]');		// select for field type

									// handling for field type select box
									fieldSelect
										.on('change', function(){
											var selectedOption = $(this).find('option:selected'),
												optionAlias = selectedOption.data('alias'),
												mandatoryStar = dialog.find("span.MandatoryStar");

											// update type element
											aliasFieldType.html(translationsDialog.tType + ": " + selectedOption.text());

											// remove class from the latest choosen field type
											if(previewFieldType.data('lastclass') !== undefined){
												previewFieldType.removeClass(previewFieldType.data('lastclass'));
											}

											// set/unset mandatory field (if choosen element is no caption field)
											dialog.find(".customFormMandatoryElement, .customFormAdditionalTextElement").css('display', ((optionAlias == "CaptionFormField")? 'none' : ''));

											previewFieldType
												.addClass(optionAlias)
												.data('lastclass', optionAlias);

											if(optionAlias == "CaptionFormField"){
												mandatoryStar.css('visibility', 'hidden');
												ep(dialog.find("input[name=FieldName]"))
													.uiValidate({required:false})
													.metaparse();
											}else{
												mandatoryStar.css('visibility', 'visible');
												ep(dialog.find("input[name=FieldName]"))
													.uiValidate({required:true})
													.metaparse();
											}

											$.tmpl('de_epages.customform.inc.customform-fieldpreview', {fieldType: optionAlias, description: selectedOption.data('description')}).appendTo(previewFieldType.empty());
										})
										.trigger('change');
								},
								buttons: [
				        	{text: translationsDialog.tAdd, type: 'submit'},
				        	{text: translationsDialog.tCancel, click: function(){ ep(this).uiDialog('close'); }}
				        ]
							});
						});
					}
				};

			init();
		},

		// delete form field
		customformDeleteField: function(selector){

      $(selector).on('click', function(evt){

      	var _this = $(this),
      		form = $(this).closest('form');
      		hidden = $('<input type="hidden" name="DeleteObjectID" value="'+_this.data('objectid')+'" />');

				// fade out parent table row
				_this.closest('tr').fadeOut();
				// add hidden input containing delete information (send and deleted when "Save" is pressed)
				hidden.appendTo(form);
      });
		}
	});

});