/*
 * @copyright   © Copyright 2006-2012, epages GmbH, All Rights Reserved.
 *
 * @module      de_epages.externalcontent.gadget.facebook
 *
 * @revision    $$
 */

jQuery.plugin('de_epages.externalcontent.gadget.facebook', {
	plugin : ['de_epages.core', 'jQuery.tmpl', 'jQuery.i18n', 'jQuery.ui.widget']
}, function ($) {
	var gClassNames = 'SocialWeb',
			templateString = '<div class="fb-like{{if boxMode}}-box{{/if}}" data-href="${url}" data-width="${width}" data-colorscheme="${color}" data-show-faces="${showFaces}" '
			+ '{{if boxMode}}data-header="${showHeader}" {{if $item.data.height}}data-height="${height}"{{/if}} data-stream="${showStream}"{{else}}data-layout="${layout}" data-action="${action}" data-send="${send}"{{/if}}></div>',
			topEp = ep;

  try {
    if(top.ep){
      topEp = top.ep;
    }
  }
  catch (error) {}

	// Render and cache template.
	$.template('de_epages.externalcontent.gadget.facebook', templateString);

	$.widget('de_epages.externalcontent.gadget.Facebook', {

		options : {
			boxMode : false,
			// Boolean. If true, show like box. If false, show like button.
			url : (topEp.config.canonicalUrl) ? topEp.config.canonicalUrl : topEp.config.baseUrl,
			// String. Specifying a site the like button or like box should reference.
			action : 'like',
			// String. Possible values: 'like', 'recommend'.
			layout : 'standard',
			// String. Possible values: 'standard', 'button_count', 'box_count'.
			send : false,
			// Boolean. If true, show "send button".
			width : 450,
			showFaces : false,
			// Boolean. If true, show profile images of people, who like the site.
			color : 'light',
			// String. Possible values 'light', 'dark'.
			showHeader : false,
			// Boolean. If true, show facebook title in box mode.
			showStream : false,
			// Boolean. If true, show comments and posts of the site as stream in box mode.
			type : 'button'
			// String. Possible values: 'button', 'box'.
		},

		_create : function () {
			var self = this,
					o = self.options;

			if (o.type === 'box') {
				o.boxMode = true;
			}

			// Prepend div with id "fb-root" for Facebook API.
			if(!$('#fb-root').length) {
				$('body')
					.prepend('<div id="fb-root"></div>');

				// AsyncInit, otherwise it is error message flame war in chrome.
				window.fbAsyncInit = function () {
    			FB.init();
				};
			}

			// Load Facebook API.
			$.ajax({
				dataType: 'script',
				url: 'https://connect.facebook.net/' + $.i18n.settings.region.replace(/-/,'_') + '/all.js',
				cache: true
			})
				.done(function(){
					// Render placeholder.
					self.placeholder = $.tmpl('de_epages.externalcontent.gadget.facebook', o).appendTo(self.element.addClass(gClassNames));
					// Parse placeholder.
					FB.XFBML.parse(self.element[0]);
				});
		},

		destroy : function () {
			var self = this;
			self.element.removeClass(gClassNames);
			if (self.placeholder) {
				self.placeholder.remove();
			}
			return self.Inherited(arguments);
		}

	});

});