jQuery.plugin("de_epages.productcomparison.inc.comparelink", {
	plugin: ['ep.core', 'de_epages.core', 'jQuery.storage', 'jQuery.ui.widget'],
}, function( $, undefined ){

	$.widget('de_epages.productcomparison.inc.compareLink', {

		options: {
			maxItemNo:              8,
			productID:              undefined,
		},

		_create: function(){
			var self = this.element,
				productID = this.options.productID;

			/* check product id */
			if (!this._check(productID, self)){
				return;
			}

			/* add 'click' event handler on associated 'Compare' link */
			self.on('click', $.proxy(function(event) {
				this._handleClick(event, self);
			}, this));
		},

		_check: function(productID) {
			if (productID === undefined || isNaN(parseInt(productID))){
				console.warn('ProductComparison: parameter \'productID\' and/or \'compare\' link missing; product comparison is removed from SF.');
				self.remove();
				return false;
			}
			return true;
		},

		_handleClick: function(event, target) {
			event.preventDefault();
			var productIDs = $.sessionStorage('Product::ProductComparison') || [],
				url = target.attr('href');
			this._addProductToComparisonList(this.options.productID, productIDs);
			$.sessionStorage('Product::ProductComparison', productIDs);
			$.each(productIDs, function(index, value){
				url += '&SelectedObjectID=' + value;
			});
			window.location = url;
		},

		_addProductToComparisonList: function(productID, productIDs) {
			var index = $.inArray(productID, productIDs);
			if (index > -1){  // deletes former occurrence
				productIDs.splice(index, 1);
			}
			productIDs.push(productID);
			while (productIDs.length > this.options.maxItemNo){
				productIDs.shift();
			}
		},

		destroy: function() {
			this.off('click');
			return this.Inherited(arguments);
		}

	});

});