jQuery.plugin(
  "de_epages.shipping.inc.deliverysettingsdialog",
  [
    'ep.ajax',
    'ep.ui.dialog',
    'jQuery.ui.draggable',
    'ep.alert'
  ],
  function ($) {

    var deliverysettingsdialog = $.scope("de_epages.shipping.inc").deliverysettingsdialog = {

      ShippingFulfillmentSettingsDialog : null,
      ShippingFulfillmentID : null,
      ShippingFulfillmentSettingsDialog_1stOpen : false,

      lock : function( lock ) {
        if ( this.ShippingFulfillmentSettingsDialog != null ) {
          this.ShippingFulfillmentSettingsDialog.parent().busy(
            ( lock ) ? 'show' : 'hide'
          );
        }
      },

      open: function (objectId) {
        this.ShippingFulfillmentID = objectId;
        this.ShippingFulfillmentSettingsDialog_1stOpen = true;
        ep('.Dialog').busy('show');
        ep.ajax({
          url: "?ViewAction=MBO-ShippingFulfillmentSettingsDialog&ObjectID=" + objectId
        })
        .done( function( data ){
          deliverysettingsdialog.show( data ) ;
        })
        .fail( function() {
          deliverysettingsdialog.ajaxError() ;
        })
        .always( function(){
          ep('.Dialog').busy('hide');
        });
      },

      show : function ( data ) {
        if ( this.ShippingFulfillmentSettingsDialog == null ) {
          this.ShippingFulfillmentSettingsDialog =
            ep( '#'+'ShippingSettingsDialog' )
              .html( data )
              .uiDialog({
                title :  ep('#ShippingSettingsDialogLabels > #DialogTitle').html(),
                modal: true,
                autoOpen: false,
                draggable: false,
                resizable: false,
                width : 800,
                height: 600,
                buttons: [
                  {
                    text: ep('#ShippingSettingsDialogLabels > #OkButton').html(),
                    click: function(){
                      deliverysettingsdialog.submit() ;
                    }
                  },
                  {
                    text: ep('#ShippingSettingsDialogLabels > #CloseButton').html(),
                    click: function(){
                      deliverysettingsdialog.close() ;
                    }
                  }
                ]
              });
        } else {
          this.ShippingFulfillmentSettingsDialog.html( data );
        }

        ep('#'+'SettingsDialog').find('.ep-js').metaparse();

        if ( this.ShippingFulfillmentSettingsDialog_1stOpen == true ){
          var InfoBox = ep( '#'+'LogisticsInfoBoxSlide' );
          if ( InfoBox.length == 1 ){
            InfoBox.hide();
            InfoBox.delay(800).animate( { opacity: 'toggle', height: 'toggle' }, 600 );
          }
          this.ShippingFulfillmentSettingsDialog_1stOpen = false;
        }
        this.ShippingFulfillmentSettingsDialog.uiDialog('open');
      },

      submit : function( newAction ) {
        var ChangeAction = null;
        var oldAction = null;
        if ( newAction != null ) {
          ChangeAction = jq( '#'+'SettingsDialog input[name=ChangeAction]' );
          oldAction = ChangeAction.val();
          ChangeAction.val( newAction );
        }
        this.lock( true );
        ep.ajax( {
          type: "POST",
          url: "?ViewAction=MBO-ShippingFulfillmentSettingsDialog&ObjectID=" + this.ShippingFulfillmentID,
          data: jq( '#'+'SettingsDialog' ).serialize()
        })
        .done( function( data ) {
          deliverysettingsdialog.reload( data );
        })
        .fail( function() {
          deliverysettingsdialog.ajaxError();
        })
        .always( function() {
          deliverysettingsdialog.lock( false );
        });
        if ( oldAction != null ) {
          ChangeAction.val( oldAction );
        }
      },

      reload : function( data ) {
        this.show( data ) ;
      },

      close : function() {
        this.ShippingFulfillmentSettingsDialog.uiDialog('close');
        if ( jq( '#'+'DialogWithErrors' ).val() == "false" ) {
          DoneShippingFulfillmentSettingsDialog() ;
        }
      },

      ajaxError : function() {
        ep.alert({
          title: ep('#ShippingSettingsDialogLabels > #AlertErrorTitle').html(),
          content: ep('#ShippingSettingsDialogLabels > #AlertErrorMessage').html(),
          type: 'warn',
          ok: function( event ) {}
        });
      }
    };
  }
);

